/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.sun.v3.sampleapplications;

import javax.ejb.*;
import javax.annotation.Resource;
import javax.naming.InitialContext;


/**
 *
 * @author marina vatkina
 */

@Stateless
public class MyBean implements BeanLocal {

    @Resource 
    private TimerService timerSvc;

    private static boolean timeout01WasCalled = false;
    private static boolean timeout02WasCalled = false;
    private static int timeout02Called = 0;

    public String createTimer() throws Exception {
        System.err.println("In MyBean:createTimer()");
        timerSvc = (TimerService) new InitialContext().lookup("java:comp/TimerService");
        //Timer t = timerSvc.createTimer(new java.util.Date(-1L), "timer01");
        Timer t = timerSvc.createTimer(10000, "timer01");
        System.err.println("In MyBean: timer1: " + t.getTimeRemaining());
        t = timerSvc.createTimer(1000, 1000, "timer02");
        System.err.println("In MyBean: timer2: " + t.getTimeRemaining());
        System.err.println("In MyBean: timers: " + timerSvc.getTimers().size());
        return "ok";
    }

    public boolean timeoutCalled() {
        boolean result = timeout01WasCalled && timeout02WasCalled;
        timeout01WasCalled = false;
        timeout02WasCalled = false;
        return result;
    }

    @Timeout
    private void timeout(Timer t) {

        System.err.println("in MyBean:timeout "  + t.getInfo() );
        System.err.println("In MyBean: timers: " + timerSvc.getTimers().size());
        if (t.getInfo().equals("timer01")) {
            timeout01WasCalled = true;
        } else if (t.getInfo().equals("timer02")) {
            timeout02WasCalled = true;
            System.err.println("In MyBean: timer2: " + t.getTimeRemaining() + " " + t.getTimeRemaining());
            timeout02Called++;
/**
            if (timeout02Called == 10) {
                t.cancel();
            }
**/
        }

    }

    public int countTimers() {
        return timerSvc.getTimers().size();
    }
}
